#include "pnm_env.h"

const float g3[3] = { 1.0F,   2.0F,  1.0F};
const float d3[3] = {-1.0F,   0.0F,  1.0F};

fKernel gx3(3,1,g3);
fKernel gy3(1,3,g3);

fKernel dx3(3,1,d3);
fKernel dy3(1,3,d3);


fRgbPix sqrtPix(fRgbPix p)
{
	return fRgbPix(sqrtf(p[0]), sqrtf(p[1]), sqrtf(p[2]));
}

fRgbPix trim(fRgbPix p)
{
	return fRgbPix (p[0] < 0 ? 0 : (p[0] > 255 ? 255 : p[0]),
					p[1] < 0 ? 0 : (p[1] > 255 ? 255 : p[1]),
					p[2] < 0 ? 0 : (p[2] > 255 ? 255 : p[2]));
}

int main()
{
	fRgbImg img = pnm(stdin);

	fRgbImg Ix = (img * gy3) * dx3;
	fRgbImg Iy = (img * dy3) * gx3;
	
	fRgbImg res = (Ix*Ix + Iy*Iy).map(sqrtPix);
	pnm((bRgbImg) res.map(trim)).Write(stdout);

	return 0;
}
